unit wsq_demo_main_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TMainForm = class(TForm)
    OutputImage: TImage;
    OpenButton: TButton;
    SaveButton: TButton;
    WSQtoStreamButton: TButton;
    StreamToWSQButton: TButton;
    RegisterButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure RegisterButtonClick(Sender: TObject);
    procedure WSQtoStreamButtonClick(Sender: TObject);
    procedure StreamToWSQButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    { Public declarations }
    bitmap : HBitmap;
    open_dialog : TOpenDialog;
    save_dialog : TSaveDialog;    
  end;


{ WSQ library declarations }
function RegisterWSQ():Integer; cdecl; external 'WSQ_library.dll' name '_RegisterWSQ';
function CreateBMPFromFile (const file_name: PCHAR): HBitmap; cdecl; external 'WSQ_library.dll' name '_CreateBMPFromFile';
function SaveBMPToFile(const bitmap: HBITMAP;  const filename: PCHAR; filetype: Integer):Integer; cdecl; external 'WSQ_library.dll' name '_SaveBMPToFile';
function CreateBMPFromWSQByteArray (input_wsq_byte_array: PCHAR; const size_of_input_wsq_byte_array: Integer): HBitmap; cdecl; external 'WSQ_library.dll' name '_CreateBMPFromWSQByteArray';
function SaveWSQByteArrayToImageFile(input_wsq_byte_array: PCHAR; const size_of_input_wsq_byte_array: Integer;  const filename: PCHAR; filetype: Integer):Integer; cdecl; external 'WSQ_library.dll' name '_SaveWSQByteArrayToImageFile';
procedure SetShowFilePropertiesDialog(file_properties_dialog: Integer); cdecl; external 'WSQ_library.dll' name '_SetShowFilePropertiesDialog';
procedure ShowFileConverter(); cdecl; external 'WSQ_library.dll' name '_ShowFileConverter';
function WSQ_decode_stream(input_data_stream: PCHAR; const input_stream_length: Integer; output_data_stream: PPCHAR; width: PInteger; height: PInteger; ppi: PInteger; comment_text: PPCHAR):Integer; cdecl; external 'WSQ_library.dll' name '_WSQ_decode_stream';
function WSQ_encode_stream(input_data_stream: PCHAR; const width: Integer; const height: Integer; const bitrate:Double;
				   const ppi: Integer; comment_text: PCHAR; output_data_stream: PPCHAR; output_stream_length: PInteger):Integer; cdecl; external 'WSQ_library.dll' name '_WSQ_encode_stream';
function ConvertHBITMAPtoGrayScale256 (const bitmap: HBITMAP): HBitmap; cdecl; external 'WSQ_library.dll' name '_ConvertHBITMAPtoGrayScale256';
function SaveHBITMAPtoFileAsGrayScale256BMP(const bitmap: HBITMAP;  const filename: PCHAR):Integer; cdecl; external 'WSQ_library.dll' name '_SaveHBITMAPtoFileAsGrayScale256BMP';



var
  MainForm: TMainForm;

   iFileHandle: Integer;
   input_data_stream, output_data_stream: PCHAR;
   input_data_stream2, output_data_stream2: PCHAR;
   image_width, image_height, ppi: Integer;
   bitrate: Double;
   comment_text: PCHAR;
   comment_text2: PCHAR;
   ret, n, input_stream_length: Integer;
   output_stream2_length: Integer;


implementation

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin

       open_dialog := TOpenDialog.Create(MainForm);
       save_dialog := TSaveDialog.Create(MainForm);
       bitmap := HBitmap(NIL);
       comment_text := PCHAR(NIL); // It is important to initialize to NIL to avoid crashing
       comment_text2 := PCHAR(NIL); // It is important to initialize to NIL to avoid crashing	   

end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin

        open_dialog.Destroy;
        save_dialog.Destroy;

end;

procedure TMainForm.FormShow(Sender: TObject);
begin

Left := (Screen.Width - Width) div 2;
Top := (Screen.Height - Height)div 2;

end;

procedure TMainForm.OpenButtonClick(Sender: TObject);
begin


    open_dialog.Filter := 'All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;*.emf;' +
'*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;*.rgba;*.rgb;' +
'*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp|' +
'FBI Wavelet Scalar Quantization (*.wsq)|*.wsq|' +
'Windows bitmaps (*.bmp)|*.bmp|' +
'Macintosh TIFF images (*.tiff)|*.tiff|' +
'PC TIFF images (*.tif)|*.tif|' +
'JPG images (*.jpg)|*.jpg|' +
'JPEG-2000 Part-1 (*.jp2)|*.jp2|' +
'JPEG-2000 Code Stream (*.jpc)|*.jpc|' +
'JPE images (*.jpe)|*.jpe|' +
'JPEG images (*.jpeg)|*.jpeg|' +
'Portable network graphic images (*.png)|*.png|' +
'Compuserve Graphic Interchange Format(*.gif)|*gif|' +
'Paintshop Pro images (*.psp)|*.psp|' +
'JFIF images (*.jfif)|*.jfif|' +
'Run length encoded Windows bitmaps (*.rle)|*.rle|' +
'Device independant Windows bitmaps (*.dib)|*.dib|' +
'Truevision images (*.win)|*.win|' +
'Truevision images (*.vst)|*.vst|' +
'Truevision images (*.vda)|*.vda|' +
'Truevision images (*.tga)|*.tga|' +
'Truevision images (*.icb)|*.icb|' +
'GFI fax images (*.fax)|*.fax|' +
'Encapsulated Postscript images (*.eps)|*.eps|' +
'ZSoft Paintbrush images (*.pcx)|*.pcx|' +
'ZSoft Paintbrush images (*.pcc)|*.pcc|' +
'Word 5.x screen capture images (*.scr)|*.scr|' +
'Alias/Wavefront images (*.rpf)|*.rpf|' +
'Alias/Wavefront images (*.rla)|*.rla|' +
'SGI true color images (*.sgi)|*.sgi|' +
'SGI true color images with alpha (*.rgba)|*.rgba|' +
'SGI true color images (*.rgb)|*.rgb|' +
'SGI black/white images (*.bw)|*.bw|' +
'Photoshop images (*.psd)|*.psd|' +
'Photoshop images (*.pdd)|*.pdd|' +
'Portable pixel map images (*.ppm)|*.ppm|' +
'Portable gray map images (*.pgm)|*.pgm|' +
'Portable bitmap images (*.pbm)|*.pbm|' +
'Autodesk images (*.cel)|*.cel|' +
'Autodesk images (*.pic)|*.pic|' +
'Kodak Photo-CD images (*.pcd)|*.pcd|' +
'Dr. Halo images (*.cut)|*.cut|' +
'Amiga Bitmap Graphic (8 bits)|*.iff|' +
'Windows icons (*.ico)|*.ico|' +
'Windows metafiles (*.wmf)|*.wmf|' +
'Windows enhanced meta files (*.emf)|*.emf';



if open_dialog.Execute() then
begin


// Take and use Handle of HBitmap directly from WSQ image library DLL.
// If the WSQ image library is called to load or save another picture, you will lose the current image
       OutputImage.Picture.Bitmap.Handle := CreateBMPFromFile( PCHAR(open_dialog.FileName));

        if ( OutputImage.Picture.Bitmap.Handle <> HBitmap(NIL)) then
        begin
           SaveButton.Enabled := True;
           OutputImage.Height := OutputImage.Picture.Bitmap.Height;
           OutputImage.Width := OutputImage.Picture.Bitmap.Width;
           Invalidate;
        end
        else
        begin
            Application.MessageBox(PCHAR('Unable to load file'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;


{
//Make a copy of HBitmap into OutputImage->Picture

     bitmap := CreateBMPFromFile( PCHAR(open_dialog.FileName));

        if ( bitmap <> HBitmap(NIL)) then
        begin
           SaveButton.Enabled := True;
           OutputImage.Picture.Bitmap.Handle  := HBitmap(CopyImage(bitmap, IMAGE_BITMAP, 0, 0,LR_COPYRETURNORG));
           OutputImage.Height := OutputImage.Picture.Bitmap.Height;
           OutputImage.Width := OutputImage.Picture.Bitmap.Width;
           Invalidate;
        end
        else
        begin
            Application.MessageBox(PCHAR('Unable to load file'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;
}



end;

end;

procedure TMainForm.RegisterButtonClick(Sender: TObject);
begin

RegisterWSQ();

end;

procedure TMainForm.SaveButtonClick(Sender: TObject);
begin


    save_dialog.Filter := 'WSQ Files (*.wsq)|*.wsq|' +  // 1
'Windows BMP (*.bmp)|*.bmp|' + // 2
'TIFF Files (*.tif)|*.tif|' + // 3
'PNG Files (*.png)|*.png|' + // 4
'JPEG Files (*.jpg)|*.jpg|' + // 5
'Targa Files (*.tga)|*.tga|' + // 6
'SGI Files (*.rgb)|*.rgb|' + // 7
'JPEG-2000 Part-1 (*.jp2)|*.jp2|' + // 8
'JPEG-2000 Code Stream (*.jpc)|*.jpc|' + // 9
'PBM - Portable Bitmap Format (*.pbm)|*.pbm|' + // 10
'PGM - Portable Graymap Format (*.pgm)|*.pgm|' + // 11
'PPM - Portable Pixmap Format (*.ppm)|*.ppm'; // 12

    save_dialog.DefaultExt := 'wsq';


if save_dialog.Execute() then
begin

       SetShowFilePropertiesDialog(1);
       SaveBMPToFile( OutputImage.Picture.Bitmap.Handle, PCHAR(save_dialog.FileName), save_dialog.FilterIndex);

end;

end;

procedure TMainForm.StreamToWSQButtonClick(Sender: TObject);
var
    x, y, row, row2, pixel_number, pixel_number2: Integer;
begin

    save_dialog.Filter := 'WSQ Files (*.wsq)|*.wsq';
    save_dialog.DefaultExt := 'wsq';

if save_dialog.Execute() then
begin
    bitrate := 0.75;
    ppi := 500;
//    comment_text2 := nil;
    comment_text2 := 'Cognaxon';
    
    if(input_data_stream2 <> PCHAR(nil)) then
    begin
    FreeMem(input_data_stream2); input_data_stream2 := PCHAR(nil);
    end;

    input_data_stream2 := PChar(AllocMem(image_width*image_height));


	// MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
    for y := 0 to (image_height - 1) do
    begin
      row := image_width * y;
      row2 := image_width * (image_height - y - 1);

        for x := 0 to (image_width - 1) do
        begin
         pixel_number := row + x;
         pixel_number2 := row2 + (image_width - x - 1);

         input_data_stream2[pixel_number2] := output_data_stream[pixel_number];
        end;
    end;


    

// THE ENCODING OF DECOMPRESSED STREAM INTO WSQ STREAM
WSQ_encode_stream(input_data_stream2, image_width, image_height, bitrate, ppi, PCHAR(comment_text2), @output_data_stream2, @output_stream2_length);


    iFileHandle := FileCreate(save_dialog.FileName);
    FileWrite(iFileHandle, output_data_stream2^, output_stream2_length);
    FileClose(iFileHandle);

Application.MessageBox(PCHAR('Memory stream was compressed into another memory stream and saved to WSQ file.' + #13#10 + 'Now please press button "Open", select the saved file, open it and have a look at the' + #13#10 + 'results of memory stream processing. The processed image is mirrored/flipped' + #13#10 + '(UP<->DOWN and LEFT<->RIGHT).'), PCHAR('WSQ image library'), MB_OK );

end;
end;

procedure TMainForm.WSQtoStreamButtonClick(Sender: TObject);
var
  iFileLength: Integer;

begin

    open_dialog.Filter := 'FBI Wavelet Scalar Quantization (*.wsq)|*.wsq';


if open_dialog.Execute() then
begin

      iFileHandle := FileOpen(open_dialog.FileName, fmOpenRead);
      iFileLength := FileSeek(iFileHandle,0,2);
      FileSeek(iFileHandle,0,0);
      input_data_stream := PChar(AllocMem(iFileLength + 1));
      input_stream_length := FileRead(iFileHandle, input_data_stream^, iFileLength);
      FileClose(iFileHandle);

      
// THE DECODING OF WSQ STREAM INTO DECOMPRESSED STREAM
WSQ_decode_stream(input_data_stream, input_stream_length, @output_data_stream, @image_width, @image_height, @ppi, @comment_text);


//Converts WSQ compressed byte array into HBITMAP for showing on screen
       OutputImage.Picture.Bitmap.Handle := CreateBMPFromWSQByteArray(input_data_stream, input_stream_length);
// Saves WSQ compressed byte array to an image file.
       //SaveWSQByteArrayToImageFile(input_data_stream, input_stream_length, PCHAR('C:\OutputDirectory\output.jpg'), 5);

        if ( OutputImage.Picture.Bitmap.Handle <> HBitmap(NIL)) then
        begin
           SaveButton.Enabled := True;
           OutputImage.Height := OutputImage.Picture.Bitmap.Height;
           OutputImage.Width := OutputImage.Picture.Bitmap.Width;
           Invalidate;
           Application.MessageBox(PCHAR('WSQ file was loaded into memory stream and decompressed into another memory stream.' + #13#10 + 'Now please press button "stream -> WSQ" to compress memory stream and save it to file.' + #13#10 + 'WSQ compressed byte array was converted to HBITMAP for showing on screen.'), PCHAR('WSQ image library'), MB_OK );
        end
        else
        begin
            Application.MessageBox(PCHAR('Error: unable to decompress WSQ byte array.'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;


       StreamToWSQButton.Enabled := True;
end;
end;

end.
